
#ifndef __AVLTREE_H
    #define __AVLTREE_H

    #include<iostream>

    
    template<class T> class AVLTreeNode;
    
    
    template<class T> class AVLTree
    {
        // template<class U> friend std::ostream& operator<<(std::ostream& os, const AVLTree<U>& tree);
        protected:
            AVLTreeNode<T>* root;
            
            void RR_rotation(AVLTreeNode<T>*& node);
            void LL_rotation(AVLTreeNode<T>*& node);
            void RL_rotation(AVLTreeNode<T>*& node);
            void LR_rotation(AVLTreeNode<T>*& node);

            bool Insert(AVLTreeNode<T>*& node, T insertion);
            void Output(std::ostream& os, AVLTreeNode<T>*& node, int depth);
            
        public:
            AVLTree();
            virtual ~AVLTree();
            bool Insert(T element);
            void Output(std::ostream& os);
    };

    
    template<class T> class AVLTreeNode
    {
        friend class AVLTree<T>;
        protected:
            AVLTreeNode* lnext;
            AVLTreeNode* rnext;
            T content;
            short balance;
            
        public:
            AVLTreeNode(T content);
            virtual ~AVLTreeNode();
    };
    
    
    #include "avl_tree.cpp" // templates
    
#endif
